dnl $Id: acinclude.m4,v 1.28 2009/07/09 04:54:26 strib Exp $

dnl The original version file was shamelessly stolen, and hevaily modified,
dnl from David Mazieres's sfs repository.

dnl xavid: API 25 compatability has a bug in MacFUSE that can be avoided
dnl        with -D__FreeBSD=10, but that confuses our platform-specific
dnl        code and is a messy hack.  However, we're not compatable with
dnl        API 26, so I'm leaving it in for now
AC_DEFUN([WFS_FUSE_FLAGS],
[
case $host_os in
    freebsd*)
        wfs_fuse_FLAGS="-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26 -D__FreeBSD__=10"
        ;;
    linux*)
        wfs_fuse_FLAGS="-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26"
        ;;
    darwin*)
        wfs_fuse_FLAGS="-D_FILE_OFFSET_BITS=64 -DFUSE_USE_VERSION=26 -D__FreeBSD__=10"
        ;;
    *)
        wfs_fuse_FLAGS=""
        ;;
esac
])

AC_DEFUN([WFS_SET_LIBMD5],
[
case $host_os in
    freebsd*)
        LIBMD5="-lmd"
        ;;
    linux*)
        LIBMD5="-lcrypto"
        ;;
    darwin*)
        LIBMD5="-lcrypto"
        ;;
    *)
        LIBMD5=""
        ;;
esac
])

AC_DEFUN([WFS_SET_LIBRT],
[
case $host_os in
    freebsd*)
        LIBRT=""
        ;;
    linux*)
        LIBRT="-lrt"
        ;;
    darwin*)
        LIBRT=""
        ;;
    *)
        LIBRT=""
        ;;
esac
])

AC_DEFUN([WFS_SET_LIBICONV],
[
case $host_os in
    freebsd*)
        LIBICONV="-liconv"
        ;;
    linux*)
        LIBICONV=""
        ;;
    darwin*)
        LIBICONV=""
        ;;
    *)
        LIBICONV=""
        ;;
esac
])

dnl
dnl find the fuse headers
dnl (originally by max in the doa repository)
dnl
AC_DEFUN([WFS_FUSE_HEADERS],
[
ac_save_CFLAGS=$CFLAGS
ac_save_LIBS=$LIBS
dirs="${prefix}/include /usr/local/include /usr/include"
AC_CACHE_CHECK(for fuse_lowlevel.h, oc_cv_fuse_h,
[for dir in " " $dirs; do
	case $dir in
		" " ) iflags="" ;;
		*)    iflags="-I${dir}/fuse/" ;;
	esac
	CFLAGS="${ac_save_CFLAGS} $iflags $wfs_fuse_FLAGS"
	AC_TRY_COMPILE([#include <fuse_lowlevel.h>], 0,
		 	oc_cv_fuse_h="${iflags}"; break)
done
if test -z ${oc_cv_fuse_h+set}
then
	oc_cv_fuse_h=no
	AC_MSG_ERROR([Could not find FUSE headers!])
fi
])
CFLAGS=$ac_save_CFLAGS
CPPFLAGS="$CPPFLAGS $oc_cv_fuse_h"
])


dnl
dnl Check for sa_len in struct sockaddrs (stolen from sfs)
dnl
AC_DEFUN([WFS_CHECK_SA_LEN],
[AC_CACHE_CHECK(for sa_len in struct sockaddr, sfs_cv_sa_len,
AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
],[
struct sockaddr sa;
sa.sa_len = 0;
], sfs_cv_sa_len=yes, sfs_cv_sa_len=no))
if test $sfs_cv_sa_len = yes; then
	AC_DEFINE(HAVE_SA_LEN, 1,
	Define if struct sockaddr has sa_len field.)
fi])


dnl
dnl find getopt_long for Strib
dnl (originally by max in the doa repository)
dnl
AC_DEFUN([WFS_GETOPT_LONG],
[
ac_save_CFLAGS=$CFLAGS
ac_save_LIBS=$LIBS
dirs="${prefix}/include /usr/local/include /usr/include"
AC_CACHE_CHECK(for getopt.h, oc_cv_getopt_h,
[for dir in " " $dirs; do
	case $dir in
		" " ) iflags="" ;;
		*)    iflags="-I${dir}" ;;
	esac
	CFLAGS="${ac_save_CFLAGS} $iflags"
	AC_TRY_COMPILE([#include <getopt.h>], 0,
		 	oc_cv_getopt_h="${iflags}"; break)
done
if test -z ${oc_cv_getopt_h+set}
then
	oc_cv_getopt_h=no
fi
])
if test "${oc_cv_getopt_h+set}" && test "$oc_cv_getopt_h" != "no"
then
	dirs="${prefix}/lib /usr/local/lib /usr/lib"
	AC_CACHE_CHECK(for libgnugetopt, oc_cv_libgnugetopt,
	[for dir in "" " " $dirs; do
		case $dir in
			"")  lflags=" " ;;
			" ") lflags="-lgnugetopt" ;;
			*)   lflags="-L${dir} -lgnugetopt" ;;
		esac
		LIBS="$ac_save_LIBS $lflags"
		AC_TRY_LINK([#include <getopt.h>],
			getopt_long (0, 0, 0, 0, 0); ,
			oc_cv_libgnugetopt=$lflags; break)
	done
	])
	if test -z ${oc_cv_libgnugetopt+set}; then
		oc_cv_libgnugetopt=no
	else
		LIBGETOPTLONG="$oc_cv_libgnugetopt"
	fi
fi
if test "$oc_cv_getopt_h" = "no" || test "$oc_cv_libgnugetopt" = "no"
then
	AC_MSG_ERROR([Could not find getopt_long])
fi
LIBS="$ac_save_LIBS"
AC_SUBST(LIBGETOPTLONG)
CFLAGS=$ac_save_CFLAGS
CPPFLAGS="$CPPFLAGS $oc_cv_getopt_h"
])

dnl
dnl find libssh headers
dnl (based on the fuse/getopt stuff above, originally by max in the doa repository)
dnl
AC_DEFUN([WFS_LIBSSH_HEADERS],
[
ac_save_CFLAGS=$CFLAGS
ac_save_LIBS=$LIBS
dirs="${prefix}/include /usr/local/include /usr/include"
AC_CACHE_CHECK(for libssh.h, oc_cv_libssh_h,
[for dir in `pwd`/libssh/include " " $dirs; do
	case $dir in
		" " ) iflags="" ;;
		*)    iflags="-I${dir}/" ;;
	esac
	CFLAGS="${ac_save_CFLAGS} $iflags"
	AC_TRY_COMPILE([#include <libssh/libssh.h>], 0,
		 	oc_cv_libssh_h="${iflags}"; break)
done
if test -z ${oc_cv_libssh_h+set}
then
	oc_cv_libssh_h="not found"
	AC_MSG_WARN([Could not find libssh headers; secure channels will be disabled.])
fi
])
if test "${oc_cv_libssh_h+set}" && test "z$oc_cv_libssh_h" != "znot found"
then
	dirs="${prefix}/lib /usr/local/lib /usr/lib"
	AC_CACHE_CHECK(for libssh, oc_cv_libssh,
	[for dir in `pwd`/libssh/libssh/.libs/ "" " " $dirs; do
		case $dir in
			"")  lflags=" " ;;
			" ") lflags="-lssh" ;;
			*)   lflags="-L${dir} -lssh" ;;
		esac
		LIBS="$ac_save_LIBS $lflags -lrt"
		AC_TRY_LINK([#include <libssh/libssh.h>
		#include <stdio.h>],
			[SSH_OPTIONS *opt = ssh_options_new(); 
			ssh_options_set_identity(opt, "%s/foo/bar");
			printf("%p",opt);
			ssh_cleanup_mem(NULL);
			WFS_MODIFIED_LIBSSH;],
			oc_cv_libssh=$lflags; break)
	done
	])
	if test -z ${oc_cv_libssh+set}; then
		oc_cv_libssh="not found"
		AC_MSG_WARN([Could not find modified libssh libraries; secure channels will be disabled.])
		LIBS="$ac_save_LIBS"
		CFLAGS="$ac_save_CFLAGS"
	else
		LIBS="$ac_save_LIBS $oc_cv_libssh"
		CFLAGS="$ac_save_CFLAGS"
		CPPFLAGS="$CPPFLAGS $oc_cv_libssh_h -DWFS_WITH_LIBSSH"
	fi
fi
])
