/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#ifndef __WFS_MAINT_H__ 
#define __WFS_MAINT_H__ 1

#include "wfs_maint_protocol.h"

#include <node_manager.h>
#include <rpc.h>
#include <wfs_node.h>

class wfs_maint {

 protected:
  wfs_node _me;
  static wfs_file_handle empty_fh;

 public:
  wfs_maint( wfs_node me ) : _me(me) {};
  virtual ~wfs_maint() {}

  virtual void add_to_repair_queue( wfs_file_id fid, wfs_node node, 
				    bool pull, bool add_to_front,
				    int32_t explicit_version = 0) = 0;
  virtual void immediate_replica_enqueue( wfs_file_handle fh ) = 0;
  virtual wfs_maint_protocol::status 
    immediate_replica_sync( wfs_file_handle fh, 
			    wfs_file_handle other_fh = empty_fh,
			    std::string append_data = "" ) = 0;
  virtual wfs_node me() {return _me;};

};

#endif // __WFS_MAINT_H
