/**
 * Copyright (c) 2009 Jeremy Stribling, Yair Sovran, Irene Zhang, 
 *                    Xavid Pretzer, Jinyang Li, Frans Kaashoek, Robert Morris,
 *     		      Massachusetts Institute of Technology,
 * 		      New York University
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */


#include <wfs_cache_mem.h>

int
main(int argc, char *argv[])
{

  system( "mkdir -p /tmp/cachetest" );

  wfs_cache_mem cache( "/tmp/cachetest", 1*1024*1024 );

  char op[5];

  do {

    scanf( "%s", op );
    if( strcmp( op, "end" ) == 0 ) {
      break;
    }

    wfs_file_id fid;
    unsigned int block_no;
    unsigned int size;
    scanf( "%"SCNx32, &fid );
    scanf( "%d", &block_no );
    scanf( "%d", &size );

    wfs_file_handle fh;
    fh.fid = fid;

    if( strcmp(op, "c") == 0 ) {
      cache.store_block( fh, wfs_version(), block_no, std::string( size, 'a' ) );
    } else if( strcmp(op, "r") == 0 ) {
      std::string buf;
      cache.read_block( fh, wfs_version(), block_no, buf );
    } else {
      printf( "Unknown op!\n" );
      exit(-1);
    }


  } while(1);

  system( "rm -rf /tmp/cachetest" );

}
